function []= analiza_interpolare(valori,flag)

    // flag = 0 afisez erorile, flag = 1 afisez timpul

    m = 50; //nr.puncte in grafic
    xmin = 0;
    xmax = 2*%pi;
    //Generare tabel de interpolat

    for i = 1:m
        mat(1, i) = xmin + (i-1)*(xmax-xmin)/(m-1); //abscisa
        mat(2, i) = sin(mat(1, i)); //Valorile exacte ale functiei 
    end;
    //
    // mat(3,i) -  valorile Newton
    // mat(4,i) - Lagrange
    // mat(5,i) - clasica


    no = length(valori);
    timp_err = zeros(no, 10);
    // coloana 1 - gradul pol de interpolare
    // coloana 2 - timp pregatire Newton
    // coloana 3 - timp evaluare Newton
    // coloana 4 - eroare Newton
    // coloana 5 - zero - nu are semnificatie
    // coloana 6 - timp evaluare procedura Lagrange (fara pregatire)
    // coloana 7 - eroare Lagrange
    // coloana 8 - timp pregatire - met clasica
    // coloana 9 - timp evaluare - met clasica
    // coloana 10 - eroare - met clasica

    for mm = 1:no
        n = valori(mm);  // gradul polinomului de interpolare
        timp_err(mm, 1) = n;
        // tabelul de interpolare
        for k=1:n+1
            x(k) = xmin + (xmax-xmin)*(k-1)/n;
            y(k) = sin(x(k));
        end;

        //Metoda Newton
        timer();
        c = prep_pol_n(n, x, y);
        t_prep = timer();
        timp_err(mm, 2) = t_prep;

        timer();
        for i = 1:m
            mat(3, i) = eval_pol_n(n, c, x, mat(1, i)); //metoda Newton
        end;
        t_eval = timer();
        timp_err(mm, 3) = t_eval;

        err = 0;
        for i = 1:m
            if (err < abs(mat(2, i) - mat(3, i))) then
                err = abs(mat(2, i) - mat(3, i));
            end;
        end;
        timp_err(mm, 4) = err;
        printf("\n Gradul polinomului: %d \n", n);
        if flag == 0
            printf(" Newton: eroare absoluta = %g \n", err);
        else
            printf(" Newton: timp pregatire = %g s; timp evaluare = %g s\n", t_prep, t_eval );
        end


        //Metoda Lagrange
        t_prep = 0;
        timp_err(mm, 5) = t_prep;
        timer();
        for i = 1:m
            mat(4, i) = eval_pol_l(n, x, y, mat(1, i)); //Metoda Lagrange
        end;
        t_eval = timer();
        timp_err(mm, 6) = t_eval;

        err = 0;
        for i = 1:m
            if (err < abs(mat(2, i) - mat(4, i))) then
                err = abs(mat(2, i) - mat(4, i));
            end;
        end;
        timp_err(mm, 7) = err;
        if flag == 0
            printf(" Lagrange fara pregatire:  eroare = %g \n", err);
        else
            printf(" Lagrange fara pregatire: timp evaluare = %g s \n", t_eval);
        end

        // Metoda clasica
        timer();
        c = prep_pol(n, x, y);
        t_prep = timer();
        timp_err(mm, 8) = t_prep;

        timer();
        for i = 1:m
            mat(5, i) = eval_pol(n, c, mat(1, i)); //metoda Clasica
        end;
        t_eval = timer();
        timp_err(mm, 9) = t_eval;

        err = 0;
        for i = 1:m
            if (err < abs(mat(2, i) - mat(5, i))) then
                err = abs(mat(2, i) - mat(5, i));
            end;
        end;
        timp_err(mm, 10) = err;
        if flag == 0
            printf(" Clasica: eroare =  %g \n",  err);
        else
            printf(" Clasica: timp pregatire = %g s; timp evaluare  = %g sec \n", t_prep, t_eval);
        end

        if flag == 0
            afisare_analiza(mat, n);
            wait2close();
        end
    end;

    if flag == 0
        afisare_err(timp_err);
    else
        afisare_timp(timp_err);
    end
endfunction

