function [eps, mat] = interpolareU(nrfunc, xmin, xmax, n)
    //x nodurile retelei de interpolare care are n+1 noduri
    //y date de interpolare (valori functie)
    //b  coeficienti din formula de interpolare
    //mat[3][M]   prima linie: z = abscise
    //            a doua linie: f = valori exacte ale functiei
    //            a treia linie: g = valori interpolate

    M = 50; // nr de puncte pentru functia exacta
    //Calculeaza valorile interpolate ale functiei
    x = zeros(n+1, 1);
    y = zeros(n+1, 1);

    //Construieste tablou de interpolat
    for k = 1:n+1
        x(k) = xmin + (xmax - xmin)*(k-1)/n;
        y(k) = func(nrfunc, x(k));
    end;


    //Construieste functia exacta
    for i = 1:M
        mat(1, i) = xmin + (xmax-xmin)*(i-1)/(M-1);
        mat(2, i) = func(nrfunc, mat(1, i));
    end;


    b = zeros(n+1, 1);
    //Construieste tablou coeficienti - metoda Lagrange
    for k = 1:n+1
        b(k) = 1;
        for j = 1:n+1
            if (j<>k) then
                b(k) = b(k)/(x(k) - x(j));
            end;
        end;
    end;


    // Evalueaza polinom

    eps = 0;
    for i=1:M
        p = 1;
        for k = 1:n+1
            p = p * (mat(1, i)-x(k));
            if (p == 0) then
                j = k;
                break;
            end;
        end;
        if (p == 0) then
            mat(3, i) = y(j);
        else
            mat(3, i) = 0;
            for k = 1 : n+1
                mat(3, i) = mat(3, i) + y(k)*b(k)/(mat(1, i) - x(k));
            end;
            mat(3, i) = mat(3, i) * p;
        end;
        p = abs(mat(3, i)  - mat(2, i));
        if (p > eps) then
            eps = p;  
        end;
    end;
    printf('\n Interpolare polinomiala uniforma');
    printf('\n    - norma Cebasev a erorii absolute este %e \n',eps);
endfunction
